#include "Gra.ch"
#include "Xbp.ch"
#include "Common.ch"
#include "Appevent.ch"
#include "Font.ch"

#pragma library( "XPPUI2.LIB" )
#pragma library( "ADAC20B.LIB" )

PROCEDURE AppSys()
RETURN

PROCEDURE dbeSys()
  IF ! DbeLoad( "DBFDBE", .F.)
     Alert( "Database-Engine DBFDBE konnte nicht geladen werden" , {"OK"} )
  ENDIF
  IF ! DbeLoad( "FOXDBE", .F.)
     Alert( "Database-Engine FOXDBE konnte nicht geladen werden" , {"OK"} )
  ENDIF
RETURN

PROCEDURE Main
LOCAL nEvent, oXbp, mp1, mp2
LOCAL oDlg

   IF FILE("XPPFATAL.LOG")
      FERASE("XPPFATAL.LOG")
   ENDIF

   oDlg := XXXdialog():New():Create()
   oDlg:Close := {|| PostAppEvent(xbeP_Quit,,, oDlg)}
*  CenterControl(oDlg)
   oDlg:Show()
   SetAppWindow( oDlg )
   SetAppFocus(oDlg)

   nEvent := xbe_None
   WHILE nEvent != xbeP_Quit
      nEvent := AppEvent ( @mp1, @mp2, @oXbp )
      oXbp:HandleEvent ( nEvent, mp1, mp2 )
      IF nEvent == xbeP_Quit
         QUIT   // AppQuit()
      ENDIF
   ENDDO

RETURN

* ----------------------------------------------------------------------- *

CLASS XXXform FROM XbpDialog
   EXPORTED:
      VAR editControls

      METHOD init
      METHOD create

      VAR oGrp
      VAR oSLE1
      VAR oSLE2
      VAR oSLE3
      VAR oSLE4
      VAR oSLE5
      VAR oSLE6
      VAR oSLE7
      VAR oSLE8
      VAR ButtonCancel
      VAR ButtonOK

ENDCLASS

METHOD XXXform:init( oParent, oOwner, aPos, aSize, aPP, lVisible )
LOCAL cVarA := SPACE(26)
LOCAL cVarB := SPACE(26)
LOCAL cVarC := SPACE(26)
LOCAL cVarD := SPACE(26)
LOCAL cVarE := SPACE(26)
LOCAL cVarF := SPACE(26)
LOCAL cVarG := SPACE(26)
LOCAL cVarH := SPACE(26)

   DEFAULT oParent  TO AppDesktop(), ;
           aPos     TO {0,0}, ;
           aSize    TO {254+50,367}, ;
           lVisible TO .F.

   DEFAULT aPP TO {}
   AAdd ( aPP, { XBP_PP_COMPOUNDNAME, "8.Arial" } )

   ::XbpDialog:init( oParent, oOwner, aPos, aSize, aPP, lVisible )
   ::XbpDialog:drawingArea:clipChildren := .T.
   ::XbpDialog:taskList := .T.
   ::XbpDialog:title := "8 Zeilen a 25 Zeichen per Copy / Paste ?"

   ::editControls := {}

   ::oGrp         := XbpStatic():new( ::drawingArea, , {16,92}, {208+50,240}, { { XBP_PP_BGCLR, -255 } } )
   ::oGrp:caption := ""
   ::oGrp:clipSiblings := .T.
   ::oGrp:type := XBPSTATIC_TYPE_GROUPBOX

   ::oSLE1        := XbpSLE():new( ::oGrp, , {4,200}, {200+50,20}, { { XBP_PP_BGCLR, XBPSYSCLR_ENTRYFIELD }, { XBP_PP_COMPOUNDNAME, "12.Courier" } } )
   ::oSLE1:bufferLength := 26
   ::oSLE1:tabStop := .T.
   ::oSLE1:dataLink := {|x| IIf( x==NIL, cVarA, cVarA := x ) }

   ::oSLE2        := XbpSLE():new( ::oGrp, , {4,172}, {200+50,20}, { { XBP_PP_BGCLR, XBPSYSCLR_ENTRYFIELD }, { XBP_PP_COMPOUNDNAME, "12.Courier" } } )
   ::oSLE2:bufferLength := 26
   ::oSLE2:tabStop := .T.
   ::oSLE2:dataLink := {|x| IIf( x==NIL, cVarB, cVarB := x ) }


   ::oSLE3        := XbpSLE():new( ::oGrp, , {4,144}, {200+50,20}, { { XBP_PP_BGCLR, XBPSYSCLR_ENTRYFIELD }, { XBP_PP_COMPOUNDNAME, "12.Courier" } } )
   ::oSLE3:bufferLength := 26
   ::oSLE3:tabStop := .T.
   ::oSLE3:dataLink := {|x| IIf( x==NIL, cVarC, cVarC := x ) }

   ::oSLE4        := XbpSLE():new( ::oGrp, , {4,116}, {200+50,20}, { { XBP_PP_BGCLR, XBPSYSCLR_ENTRYFIELD }, { XBP_PP_COMPOUNDNAME, "12.Courier" } } )
   ::oSLE4:bufferLength := 26
   ::oSLE4:tabStop := .T.
   ::oSLE4:dataLink := {|x| IIf( x==NIL, cVarD, cVarD := x ) }

   ::oSLE5        := XbpSLE():new( ::oGrp, , {4, 88}, {200+50,20}, { { XBP_PP_BGCLR, XBPSYSCLR_ENTRYFIELD }, { XBP_PP_COMPOUNDNAME, "12.Courier" } } )
   ::oSLE5:bufferLength := 26
   ::oSLE5:tabStop := .T.
   ::oSLE5:dataLink := {|x| IIf( x==NIL, cVarE, cVarE := x ) }

   ::oSLE6        := XbpSLE():new( ::oGrp, , {4, 60}, {200+50,20}, { { XBP_PP_BGCLR, XBPSYSCLR_ENTRYFIELD }, { XBP_PP_COMPOUNDNAME, "12.Courier" } } )
   ::oSLE6:bufferLength := 26
   ::oSLE6:tabStop := .T.
   ::oSLE6:dataLink := {|x| IIf( x==NIL, cVarF, cVarF := x ) }

   ::oSLE7        := XbpSLE():new( ::oGrp, , {4, 32}, {200+50,20}, { { XBP_PP_BGCLR, XBPSYSCLR_ENTRYFIELD }, { XBP_PP_COMPOUNDNAME, "12.Courier" } } )
   ::oSLE7:bufferLength := 26
   ::oSLE7:tabStop := .T.
   ::oSLE7:dataLink := {|x| IIf( x==NIL, cVarG, cVarG := x ) }

   ::oSLE8        := XbpSLE():new( ::oGrp, , {4,  4}, {200+50,20}, { { XBP_PP_BGCLR, XBPSYSCLR_ENTRYFIELD }, { XBP_PP_COMPOUNDNAME, "12.Courier" } } )
   ::oSLE8:bufferLength := 26
   ::oSLE8:tabStop := .T.
   ::oSLE8:dataLink := {|x| IIf( x==NIL, cVarH, cVarH := x ) }

   ::ButtonCancel := XbpPushButton():new( ::drawingArea, , {16,16}, {64,64}, { { XBP_PP_BGCLR, XBPSYSCLR_BUTTONMIDDLE }, { XBP_PP_FGCLR, -58 } } )
   ::ButtonCancel:caption := "Abbruch"
   ::ButtonCancel:tabStop := .T.
   ::ButtonCancel:activate := {|| PostAppEvent( xbeP_Close ) }

   ::ButtonOK     := XbpPushButton():new( ::drawingArea, , {156+50,16}, {64,64}, { { XBP_PP_BGCLR, XBPSYSCLR_BUTTONMIDDLE }, { XBP_PP_FGCLR, -58 } } )
   ::ButtonOK:caption := "Ok"
   ::ButtonOK:tabStop := .T.
   ::ButtonOK:activate := {|| Gather( ::editControls ), PostAppEvent( xbeP_Close ) }

RETURN self

METHOD XXXform:create( oParent, oOwner, aPos, aSize, aPP, lVisible )

   ::XbpDialog:create( oParent, oOwner, aPos, aSize, aPP, lVisible )

   ::oGrp:create()
   ::oSLE1:create()
   ::oSLE2:create()
   ::oSLE3:create()
   ::oSLE4:create()
   ::oSLE5:create()
   ::oSLE6:create()
   ::oSLE7:create()
   ::oSLE8:create()

   ::ButtonCancel:create()
   ::ButtonOK:create()

   AADD(::editControls,::oSLE1)
   AADD(::editControls,::oSLE2)
   AADD(::editControls,::oSLE3)
   AADD(::editControls,::oSLE4)
   AADD(::editControls,::oSLE5)
   AADD(::editControls,::oSLE6)
   AADD(::editControls,::oSLE7)
   AADD(::editControls,::oSLE8)

RETURN self

CLASS XXXdialog FROM XXXform
   PROTECTED:
      METHOD NewTextDocument()
      METHOD ValidateFormat()
      METHOD GetDropData()

   EXPORTED:
      VAR CurrData

      METHOD Init()
      METHOD Create()

      METHOD Resize()
      METHOD HandleDragEnter()
      METHOD HandleDragDrop()
      METHOD HandleDragLeave()

      METHOD NewDocument()
      METHOD Text2SLE()

ENDCLASS

METHOD XXXdialog:init( oParent, oOwner, aPos, aSize, aPP, lVisible )

   ::XXXform:init( oParent, oOwner, aPos, aSize, aPP, lVisible )

   ::DrawingArea:DropZone  := .T.
   ::DrawingArea:DragEnter := { | aState, oData | ::HandleDragEnter( aState, oData ) }
   ::DrawingArea:DragLeave := { | aState, uNIL  | ::HandleDragLeave( aState, ) }
   ::DrawingArea:DragDrop  := { | aState, oData | ::HandleDragDrop( aState, oData ) }

RETURN self

METHOD XXXdialog:create( oParent, oOwner, aPos, aSize, aPP, lVisible )
   ::XXXform:create( oParent, oOwner, aPos, aSize, aPP, lVisible )
RETURN self

METHOD XXXdialog:Resize( aOldSize, aNewSize )
LOCAL aDASize := ::CalcClientRect( {0,0,aNewSize[1],aNewSize[2]} )
   aDASize := {aDASize[3] - aDASize[1],aDASize[4] - aDASize[2]}
RETURN self

METHOD XXXdialog:HandleDragEnter( aState, oData )
LOCAL nReturn := XBP_DROPMODE_NONE

   UNUSED( aState )

   ::CurrData := ::ValidateFormat( oData )
   IF Len(::CurrData) > 0
      nReturn := XBP_DROPMODE_COPY
   ENDIF

RETURN nReturn

METHOD XXXdialog:HandleDragLeave( aState )
   ::CurrData := NIL
RETURN self

METHOD XXXdialog:HandleDragDrop( aState, oData)
LOCAL i

   FOR i:=1 TO Len(::CurrData)
      ::NewDocument( ::CurrData[i][1], ::CurrData[i][2] )
   NEXT

RETURN XBP_DROPMODE_COPY

METHOD XXXdialog:ValidateFormat(oData)
LOCAL aReturn := {}
   IF oData:QueryGetFormat(XBPCLPBRD_TEXT) == .T.
      RETURN {{"TEXT", ::GetDropData("TEXT", oData)}}
   ENDIF
RETURN aReturn

METHOD XXXdialog:GetDropData( cFormat, xData )
   IF cFormat == "TEXT"
      IF ValType(xData) == "O"
         RETURN xData:GetData( XBPCLPBRD_TEXT )
      ENDIF

      RETURN MemoRead( xData )
   ENDIF
RETURN NIL

METHOD XXXdialog:NewDocument( cFormat, xData )

   ::DrawingArea:SetPointer(, XBPSTATIC_SYSICON_WAIT )

   IF cFormat == "TEXT"
      ::NewTextDocument( xData, "Text" )
   ENDIF

   ::DrawingArea:SetPointer(, XBPSTATIC_SYSICON_DEFAULT )

RETURN

METHOD XXXdialog:NewTextDocument( xData, cTitle )
  ::Text2SLE(xData)
RETURN

METHOD XXXdialog:Text2SLE(cText)
LOCAL i
LOCAL iMax  := LEN( ::editControls )
LOCAL cLine := ""
LOCAL nPos  := 1

   FOR i := 1 TO iMax
      ::editControls[i]:setdata(SPACE(26))
   NEXT

   FOR i := 1 TO iMax
      cLine := SUBSTR(cText,nPos,26)
      ::editControls[i]:setdata(cLine)

      cText := STRTRAN(cText,cLine,"")
      IF EMPTY(cText)
         EXIT
      ENDIF
   NEXT

RETURN NIL

* ----------------------------------------------------------------------- *

//EOF
/////